// Listing 3.2: Recursive Routine to List a Directory

// Function to list a directory structure. Assumes
// the array parameter contains file and directory
// names in a structure defined by the 6 manifest
// constants

#include "Directry.ch"
#include "Commands.ch"

#define   F_SUBDIR       6
#define   SUBDIR_INDENT  4

FUNCTION DirList(aStartDir, nIndent)

LOCAL i

  DEFAULT nIndent TO 0
  FOR i = 1 TO Len(aStartDir)

    ? Space(nIndent),                 ;
      Pad(aStartDir[i, F_NAME], 12),  ;
      Iif("D" $ aStartDir[i, F_ATTR], ;
         "<DIR>     ",                ;
         aStartDir[i, F_SIZE]),       ;
      aStartDir[i, F_DATE],           ;
      aStartDir[i, F_TIME],           ;
      aStartDir[i, F_ATTR]

    IF "D" $ aStartDir[i, F_ATTR]     .AND. ;
       !(aStartDir[i, F_NAME] == "."  .OR.  ;
         aStartDir[i, F_NAME] == "..")
      DirList(aStartDir[i, F_SUBDIR], ;
              nIndent + SUBDIR_INDENT)
    ENDIF

  NEXT

RETURN NIL
