// Listing 3.4: Printing a nested array.

/***
* PrintArray(aR, cTitle)
*
*  aR[]     - -Array to print
*  cTitle   - -The heading
*
*  Recursive routine to print an array
*/

FUNCTION PrintArray(aR, cTitle)

LOCAL i := 0, cHeading

  // Step through every array element. If the element is
  // itself an array, recurse to print the subarray,
  // just print the element name and subscript.

  AEval(aR, {|elem|  ;
         i++,  ;
         cHeading := cTitle + "[" + Ltrim(Str(i)) + "]", ;
              Iif(ValType(elem) = "A",        ;
                  PrintArray(elem, cHeading), ;
                  Qout(cHeading, elem))         ;
            })

RETURN NIL
