// Listing 3.6: Saving an array to a file

/***
* SAVE_ARR.PRG
*
* Program file containg SaveArray() and RestArray() functions
* to save and restore arrays to / from disk.
* Must compile with /n
*/

#include "Save_arr.ch"

/***
*   SaveArray(aArray, cFileName)
*
*    aArray[]    - -Array to save
*    cFileName   - -File in which to save array
*/

FUNCTION SaveArray(aArray, cFileName)

LOCAL fHandle := FCreate(cFileName)

  SaveArr(fHandle, aArray)
  FClose(fHandle)

RETURN NIL


STATIC FUNCTION SaveArr(fHandle, aArray)

LOCAL LenArray, ElemType, i

  // Write the array header
  WRITE_AHD(fHandle, aArray)
  LenArray := Len(aArray)

  // Write each element in the array ~EL
  FOR i := 1 TO LenArray
    ElemType := ValType(aArray[i])
    DO CASE
      CASE ElemType == "A"
        // A subarray, recurse ~EL
        SaveArr(fHandle, aArray[i])

      CASE ElemType == "B"
        // Fatal error here- -we cannot write blocks
        ? "ERROR: CANNOT SAVE A CODE BLOCK"
        InKey(0)

      CASE ElemType == "C"
        // Save a character element
        SAVE_CHAR(fHandle, aArray[i])

      CASE ElemType == "D"
        // Save a date element
        SAVE_DATE(fHandle, aArray[i])

      CASE ElemType == "L"
        // Save a logical element
        SAVE_LOG(fHandle, aArray[i])

      CASE ElemType == "N"
        // Save a numeric element
        SAVE_NUM(fHandle, aArray[i])
    ENDCASE
  NEXT

RETURN NIL
