// Listing 4.7: Restoring an array from a file

/***
* SAVE_ARR.PRG
*
* Program file containing SaveArray() and RestArray() functions
* to save and restore arrays to / from disk.
* Must compile with /n
*/

#include "save_arr.ch"

/***
*    RestArray(cFileName)
*
*    cFileName   - -File from which to restore array
*/

FUNCTION RestArray(cFileName)

LOCAL aRestArr, fHandle := FOpen(cFileName)

  GET_TYPE(fHandle)
  aRestArr := RestArr(fHandle)
  FClose(fHandle)

RETURN aRestArr


FUNCTION RestArr(fHandle)

LOCAL LenArray, i, ElemType, aArray

  // Determine array's size and allocate it
  LenArray := GET_AR_SIZE(fHandle)
  aArray   := Array(LenArray)

  // Restore each element
  FOR i := 1 TO LenArray
    // Determine its type
    ElemType := GET_TYPE(fHandle)
    DO CASE
      CASE ElemType == "A"
        // A sub array so recurse ~EL
        aArray[i] := RestArr(fHandle)

      CASE ElemType == "B"
        // Fatal error here ... we did not save one

      CASE ElemType == "C"
        aArray[i] := GET_CHAR(fHandle)

      CASE ElemType == "D"
        aArray[i] := GET_DATE(fHandle)

      CASE ElemType == "L"
        aArray[i] := GET_LOG(fHandle)

      CASE ElemType == "N"
        aArray[i] := GET_NUM(fHandle)

    ENDCASE
  NEXT

RETURN aArray
