// Listing 3.5: Macros to read and write array elements

/***
*  SAVE_ARR.CH
*
* Clipper header file for array save and restore
*
*/

//  In the following macros fh is a file handle

// Write character element: C<5 digit length><character value>
#define SAVE_CHAR(fh, cv) FWrite(fh, "C" + Str(Len(cv), 5) + cv)

// Write date element:      D<datestring>
#define SAVE_DATE(fh, dv) FWrite(fh, "D" + Dtoc(dv))

// Write logical element:   L<T or F character>
#define SAVE_LOG(fh, lv)  FWrite(fh, "L" + Iif(lv, "T", "F"))

// Write numeric element:
//                          N<2 digit length>
//                           <numeric formatted as a string>
#define SAVE_NUM(fh, nv) FWrite(fh, "N" + Str(Len(Str(nv)),2) + ;
                                Str(nv))

// Write array header:      A<4 digit array length>
#define WRITE_AHD(fh, av) FWrite(fh, "A" + Str(Len(av), 4))

// Read a type
#define GET_TYPE(fh)     FReadStr(fh, 1)

// Read an array size
#define GET_AR_SIZE(fh) Val(FReadStr(fh, 4))

// Read a character element
#define GET_CHAR(fh)    FReadStr(fh, Val(FReadStr(fh, 5)))

// Read a date element
#define GET_DATE(fh)    Ctod(FReadStr(fh, 8))

// Read a logical element
#define GET_LOG(fh)     FReadStr(fh, 1) == "T"

// Read a numeric element
#define GET_NUM(fh)     Val(FReadStr(fh, Val(FReadStr(fh, 2))))
